//
//  BoardGameDetailView.swift
//  Games
//
//  Created by Ben Albright on 11/29/23.
//

import SwiftUI

struct BoardGameDetailView: View {
    var body: some View {
        VStack{
            Image("betrayal")
                .resizable()
                .scaledToFit()
                .padding(.horizontal)
                .padding(.top,30)
            
            HStack {
                Text("Betrayal at House on the Hill")
                    .font(.title)
                    .fontWeight(.bold)
                Spacer()
            }
            .padding(.horizontal)
            .padding(.bottom)

            
            HStack{
                Text("2-5 Players")
                Text("40 Min")
                Text("2009")
                Text("Publisher")
                Spacer()
            }
            .padding(.horizontal)
            .font(.title3)
            .fontWeight(.semibold)
            .padding(.bottom)
            
            Text("Betrayal at House on the Hill quickly builds suspense and excitement as players explore a haunted mansion of their own design, encountering spirits and frightening omens that foretell their fate. With an estimated one hour playing time, Betrayal at House on the Hill is ideal for parties, family gatherings or casual fun with friends. Betrayal at House on the Hill is a tile game that allows players to build their own haunted house room by room, tile by tile, creating a new thrilling game board every time. The game is designed for three to six people, each of whom plays one of six possible characters. Secretly, one of the characters betrays the rest of the party, and the innocent members of the party must defeat the traitor in their midst before it’s too late! Betrayal at House on the Hill will appeal to any game player who enjoys a fun, suspenseful, and strategic game.")
                .lineLimit(6)
                .padding(.horizontal)
            
            Spacer()
            
            Button("Add to Collection") {
                
            }
            .padding()
            .background(Color("nd-purple"))
            .clipShape(Capsule())
            .padding(.bottom,30)
            .foregroundColor(.white)
            .font(.title)
            .fontWeight(.bold)
            .padding(.top)
            
        }
        .multilineTextAlignment(.leading)
    }
}

#Preview {
    BoardGameDetailView()
}
