//
//  DiceView.swift
//  Games
//
//  Created by Ben Albright on 11/29/23.
//

import SwiftUI

struct DiceView: View {
    
    @State var number = 1
    
    var body: some View {
        VStack {
            Image("number\(number)")
                .resizable()
                .frame(width: 300, height: 300)
        
            Button(action: {
                number = Int.random(in:1...6)
            }){
                Text("Roll")
                    .fontWeight(.bold)
                    .font(.title)
            }
            .padding()
            .background(Color("nd-purple"))
            .clipShape(Capsule())
            .padding(.bottom,30)
            .foregroundColor(.white)
            .font(.title)
            .fontWeight(.bold)
            .padding(.top)
            
        }
        .padding()
    }
}

#Preview {
    DiceView()
}
