//
//  FeedView.swift
//  Games
//
//  Created by Ben Albright on 10/18/23.
//

import SwiftUI

struct FeedView: View {
    
    @State var postContent: String = ""
    @State var duration: String = ""
    @State var numPlayer: String = ""
    
    var body: some View {
        NavigationView{
            VStack {
                HStack {
                    
                    Text("Your Feed")
                        .fontWeight(.bold)
                        .padding(.top)
                        .font(.custom("Montserrat", size: 34))
                    
                    Spacer()
                    
                    Image("with-pips")
                        .resizable()
                        .scaledToFit()
                        .frame(width: 80, height: 80)

                }
                .hAlign(.leading)
                .padding(.horizontal)
                
                NavigationLink(destination: PostView()){
                    VStack{
                        Text("**Ben A (@BenBoardGames)** just played")
                            .padding(.horizontal)
                            .hAlign(.leading)
                            .font(.title2)
                            .font(.custom("Montserrat", size: 28))

                        
                        HStack{
                            Image("betrayal")
                                .resizable()
                                .scaledToFit()
                                .frame(width: 80, height: 80)
                            
                            VStack {
                                HStack {
                                    Text("Betrayal at House on the Hill")
                                        .fontWeight(.bold)
                                        .font(.title3)
                                        .font(.custom("Montserrat", size: 22))

                                    Spacer()
                                }
                                HStack {
                                    Text("2-5 Players")
                                        .font(.custom("Montserrat", size: 18))

                                    Text("60 Min")
                                        .font(.custom("Montserrat", size: 18))

                                    Spacer()

                                }
                                HStack{
                                    Text("Avalon Hill")
                                        .font(.custom("Montserrat", size: 18))

                                    Text("2004")
                                        .font(.custom("Montserrat", size: 18))

                                    Spacer()
                                }
                            }
                        }
                        .padding(.horizontal)
                        
                        VStack{
                            Image("star-ratings")
                                .resizable()
                                .scaledToFit()
                                .padding(.horizontal)
                                .hAlign(.center)
                            Text("Review")
                                .padding(.horizontal)
                                .hAlign(.leading)
                                .font(.title3)
                                .fontWeight(.bold)
                            Text("Just played Betrayal for the first time in a while, and man, what a twist. Not only did I fall into the basement at the very beginning, I also ended up becoming the villain during the haunt. The gang was no match for my pet dragon! Another win in the books. Can't wait to play it again when I'm back home for the holidays.")
                                .lineLimit(6)
                                .padding(.horizontal)
                                .font(.custom("Montserrat", size: 18))
                        }
                    }
                    .foregroundColor(.black)
                    .multilineTextAlignment(.leading)
                    .border(1, .gray.opacity(0.5))
                }
                
                Spacer()
                
                HStack {
                    Spacer()
                    
                    NavigationLink(destination: ContentView()){
                        Image(systemName: "plus.circle.fill")
                            .resizable()
                            .scaledToFit()
                            .padding(.horizontal)
                            .frame(width: 100, height: 100)
                    }
                }
                

            }
            .vAlign(.top)
            
        }
    }
}

#Preview {
    FeedView()
}

