//
//  GameLibraryView.swift
//  Games
//
//  Created by Ben Albright on 11/29/23.
//

import SwiftUI

struct GameLibraryView: View {
    
    var gameList = [
        boardGame(name: "Betrayal at House on the Hill", players: "2-6 Players", duration: "60 Min", publisher: "Avalon Hill", pubYear: "2004", image: "betrayal", description: "Betrayal at House on the Hill quickly builds suspense and excitement as players explore a haunted mansion of their own design, encountering spirits and frightening omens that foretell their fate. With an estimated one hour playing time, Betrayal at House on the Hill is ideal for parties, family gatherings or casual fun with friends. Betrayal at House on the Hill is a tile game that allows players to build their own haunted house room by room, tile by tile, creating a new thrilling game board every time. The game is designed for three to six people, each of whom plays one of six possible characters. Secretly, one of the characters betrays the rest of the party, and the innocent members of the party must defeat the traitor in their midst before it’s too late! Betrayal at House on the Hill will appeal to any game player who enjoys a fun, suspenseful, and strategic game."),
        boardGame(name: "Battleship", players: "2 Players", duration: "30 Min", publisher: "3M", pubYear: "1931", image: "bship", description: "Battleship was originally a pencil-and-paper public domain game known by different names, but Milton Bradley made it into the well known board game in 1967. The pencil and paper grids were changed to plastic grids with holes that could hold plastic pegs used to record the guesses. Each player deploys his ships (of lengths varying from 2 to 5 squares) secretly on a square grid. Then each player shoots at the other's grid by calling a location. The defender responds by 'Hit!' or 'Miss!'. You try to deduce where the enemy ships are and sink them. First to do so wins. The Salvo variant listed in the rules allows each player to call out from 1 to 5 shots at a time depending on the amount of ships the player has left (IE: players each start off with 5 ships, so they start off with 5 shots. As ships are sunk, the players gets fewer shots). This version of the game is closer to the original pencil-and-paper public domain game. Many versions of the pencil-and-paper game have different amounts of shots based on the ship (IE: Battleship: 5 shots. Destroyer: 3 Shots, Etc.)."),
        boardGame(name: "CATAN", players: "2-4 Players", duration: "60-120 Min", publisher: "KOSMOS", pubYear: "1995", image: "catan", description: "In CATAN (formerly The Settlers of Catan), players try to be the dominant force on the island of Catan by building settlements, cities, and roads. On each turn dice are rolled to determine what resources the island produces. Players build by spending resources (sheep, wheat, wood, brick and ore) that are depicted by these resource cards; each land type, with the exception of the unproductive desert, produces a specific resource: hills produce brick, forests produce wood, mountains produce ore, fields produce wheat, and pastures produce sheep. Setup includes randomly placing large hexagonal tiles (each showing a resource or the desert) in a honeycomb shape and surrounding them with water tiles, some of which contain ports of exchange. Number disks, which will correspond to die rolls (two 6-sided dice are used), are placed on each resource tile. Each player is given two settlements (think: houses) and roads (sticks) which are, in turn, placed on intersections and borders of the resource tiles. Players collect a hand of resource cards based on which hex tiles their last-placed house is adjacent to. A robber pawn is placed on the desert tile."),
        boardGame(name: "Dixit", players: "3-8 Players", duration: "30 Min", publisher: "Libellud", pubYear: "2008", image: "dixit", description: "Each turn in Dixit, one player is the storyteller, chooses one of the six cards in their hand, then makes up a sentence based on that card's image and says it out loud without showing the card to the other players. Each other player then selects the card in their hand that best matches the sentence and gives the selected card to the storyteller, without showing it to anyone else. The storyteller shuffles their card with all of the received cards, then reveals all of these cards. Each player other than the storyteller then secretly guesses which card belongs to the storyteller. If nobody or everybody guesses the correct card, the storyteller scores 0 points, and each other player scores 2 points. Otherwise, the storyteller and whoever found the correct answer score 3 points. Additionally, the non-storyteller players score 1 point for every vote received by their card. The game ends when the deck is empty or if a player has scored at least 30 points. In either case, the player with the most points wins."),
        boardGame(name: "Pandemic", players: "2-4 Players", duration: "45 Min", publisher: "Z-Man Games", pubYear: "2008", image: "pandemic", description: "In Pandemic, several virulent diseases have broken out simultaneously all over the world! The players are disease-fighting specialists whose mission is to treat disease hotspots while researching cures for each of four plagues before they get out of hand. The game board depicts several major population centers on Earth. On each turn, a player can use up to four actions to travel between cities, treat infected populaces, discover a cure, or build a research station. A deck of cards provides the players with these abilities, but sprinkled throughout this deck are Epidemic! cards that accelerate and intensify the diseases' activity. A second, separate deck of cards controls the 'normal' spread of the infections."),
        boardGame(name: "The Quacks of Quedlinburg", players: "2-4 Players", duration: "45 Min", publisher: "Schmidt Spiele", pubYear: "2018", image: "quacks", description: "In The Quacks of Quedlinburg, players are charlatans — or quack doctors — each making their own secret brew by adding ingredients one at a time. Take care with what you add, though, for a pinch too much of this or that will spoil the whole mixture! Each player has their own bag of ingredient chips. During each round, they simultaneously draw chips from their bags and add them to their pots. The higher the face value of the drawn chip, the further it is placed in the pot's swirling pattern, increasing how much the potion will be worth. Push your luck as far as you can, but if you add too many cherry bombs, your pot will explode! At the end of each round, players gain victory points and coins to spend on new ingredients, depending on how well they managed to fill up their pots. But players whose pots have exploded must choose points or coins — not both! The player with the most victory points at the end of nine rounds wins the game."),
        boardGame(name: "Sagrada", players: "1-4 Players", duration: "45 Min", publisher: "Floodgate Games", pubYear: "2017", image: "sagrada", description: "Draft dice and use the tools-of-the-trade in Sagrada to carefully construct your stained glass window masterpiece. In more detail, each player builds a stained glass window by building up a grid of dice on their player board. Each board has some restrictions on which color or shade (value) of die can be placed there. Dice of the same shade or color may never be placed next to each other. Dice are drafted in player order, with the start player rotating each round, snaking back around after the last player drafts two dice. Scoring is variable per game based on achieving various patterns and varieties of placement...as well as bonus points for dark shades of a particular hidden goal color. Special tools can be used to help you break the rules by spending skill tokens; once a tool is used, it then requires more skill tokens for the other players to use them."),
        boardGame(name: "Sorry!", players: "2-4 Players", duration: "20 Min", publisher: "Basic Fun", pubYear: "1929", image: "sorry", description: "Race your four game pieces from Start around the board to your Home in this Pachisi type game. By turning over a card from the draw deck and following its instructions, players move their pieces around the game board, switch places with players, and knock opponents' pieces off the track and back to their Start position. Slides are located at various places around the game board. When a player's piece lands at the beginning of one of these slides not of its own color, it automatically advances to the end, removing any piece on the slide and sending it back to Start."),
        boardGame(name: "Tokaido", players: "2-5 Players", duration: "45 Min", publisher: "Funforge", pubYear: "2012", image: "tokaido", description: "In Tokaido, each player is a traveler crossing the 'East sea road', one of the most magnificent roads of Japan. While traveling, you will meet people, taste fine meals, collect beautiful items, discover great panoramas, and visit temples and wild places but at the end of the day, when everyone has arrived at the end of the road you'll have to be the most initiated traveler – which means that you'll have to be the one who discovered the most interesting and varied things. The potential action spaces in Tokaido are laid out on a linear track, with players advancing down this track to take actions. The player who is currently last on the track takes a turn by advancing forward on the track to their desired action and taking that action, so players must choose whether to advance slowly in order to get more turns, or to travel more rapidly to beat other players to their desired action spaces."),
        boardGame(name: "Wingspan", players: "1-5 Players", duration: "40-70 Min", publisher: "Stonemaier Games", pubYear: "2019", image: "wingspan", description: "Wingspan is a competitive, medium-weight, card-driven, engine-building board game from Stonemaier Games. It's designed by Elizabeth Hargrave and features over 170 birds illustrated by Beth Sobel, Natalia Rojas, and Ana Maria Martinez. You are bird enthusiasts—researchers, bird watchers, ornithologists, and collectors—seeking to discover and attract the best birds to your network of wildlife preserves. Each bird extends a chain of powerful combinations in one of your habitats (actions). These habitats focus on several key aspects of growth.")]
    
    @State var showDetailView: Bool = false
    @State var selectedGame: boardGame?
    @State private var searchText = ""
    
    var body: some View {
        NavigationView{
            VStack{
                SearchBar(text: $searchText)
                
                List(gameList, id: \.name) { boardGame in
                    NavigationLink(destination: NewDetailView(game: boardGame)) {
                        HStack {
                            Image(boardGame.image)
                                .resizable()
                                .frame(width: 100, height: 100)
                                .cornerRadius(5)
                            VStack {
                                HStack {
                                    Text(boardGame.name)
                                        .fontWeight(.bold)
                                        .font(.title2)
                                    Spacer()
                                }
                                HStack {
                                    Text(boardGame.players)
                                    Text(boardGame.duration)
                                    Spacer()
                                }
                                HStack{
                                    Text(boardGame.publisher)
                                    Text(boardGame.pubYear)
                                    Spacer()
                                }
                            }
                        }
                    }
                }
                .listStyle(.plain)
                .navigationBarTitle("Game Library")
            }
        }
    }
}


#Preview {
    GameLibraryView()
}
    
struct boardGame{
    var name: String
    var players: String
    var duration: String
    var publisher: String
    var pubYear: String
    var image: String
    var description: String
}

struct SearchBar: UIViewRepresentable {
    
    @Binding var text: String
    
    func makeUIView(context: Context) -> UISearchBar {
        let searchBar = UISearchBar()
        searchBar.searchBarStyle = .minimal
        searchBar.autocapitalizationType = .none
        searchBar.placeholder = "Search..."
        return searchBar
    }
    
    func updateUIView(_ uiView: UISearchBar, context: Context) {
        uiView.text = text
    }
}

struct SearchBar_Previews: PreviewProvider {
    static var previews: some View {
        SearchBar(text: .constant(""))
    }
}

struct NewDetailView: View {
    
    var game: boardGame
    
    var body: some View {
        VStack{
            Image(game.image)
                .resizable()
                .scaledToFit()
                .padding(.horizontal)
                .padding(.top,30)
            
            HStack {
                Text(game.name)
                    .font(.title)
                    .fontWeight(.bold)
                Spacer()
            }
            .padding(.horizontal)
            .padding(.bottom)

            
            HStack{
                Text(game.players)
                Text(game.duration)
                Text(game.pubYear)
                Text(game.publisher)
                Spacer()
            }
            .padding(.horizontal)
            .font(.title3)
            .fontWeight(.semibold)
            .padding(.bottom)
            
            Text(game.description)
                .lineLimit(6)
                .padding(.horizontal)
            
            Spacer()
            
            Button("Add to Collection") {
                
            }
            .padding()
            .background(Color("nd-purple"))
            .clipShape(Capsule())
            .padding(.bottom,30)
            .foregroundColor(.white)
            .font(.title)
            .fontWeight(.bold)
            .padding(.top)
            
        }
        .multilineTextAlignment(.leading)    }
}
