//
//  PostView.swift
//  Games
//
//  Created by Ben Albright on 10/18/23.
//

import SwiftUI

struct PostView: View {
    var body: some View {
        VStack{
            Text("**Ben A (@BenBoardGames)** just played")
                .padding(.horizontal)
                .hAlign(.leading)
                .font(.title2)
                .font(.custom("Montserrat", size: 25))
            
            Image("betrayal")
                .resizable()
                .scaledToFit()
                .padding(.horizontal)
                .padding()
            
            HStack {
                Text("Betrayal at House on the Hill")
                    .font(.title3)
                    .fontWeight(.bold)
                    .font(.custom("Montserrat", size: 22))

                Spacer()
            }
            .padding(.horizontal)
            .hAlign(.leading)
            
            Image("star-ratings")
                .resizable()
                .scaledToFit()
                .padding(.horizontal,10)
                .hAlign(.leading)
            }
            .padding(.horizontal)
            .font(.title3)
            .fontWeight(.semibold)
            .padding(.bottom)
            
            Text("Just played Betrayal for the first time in a while, and man, what a twist. Not only did I fall into the basement at the very beginning, I also ended up becoming the villain during the haunt. The gang was no match for my pet dragon! Another win in the books. Can't wait to play it again when I'm back home for the holidays.")
                .font(.custom("Montserrat", size: 18))
                .padding(.horizontal, 30)
                .vAlign(.top)
                .hAlign(.leading)
            
        .multilineTextAlignment(.leading)
    }
}

#Preview {
    PostView()
}
